<div>
  <h2>
    <span id="metrics-page-heading" csiTranslate="metrics.title" data-cy="metricsPageHeading">Application Metrics</span>

    <button class="btn btn-primary float-end" (click)="refresh()">
      <fa-icon icon="sync"></fa-icon> <span csiTranslate="metrics.refresh.button">Refresh</span>
    </button>
  </h2>

  <h3 csiTranslate="metrics.jvm.title">JVM Metrics</h3>

  <div class="row" *ngIf="metrics && !updatingMetrics">
    <csi-jvm-memory class="col-md-4" [updating]="updatingMetrics" [jvmMemoryMetrics]="metrics.jvm"></csi-jvm-memory>

    <csi-jvm-threads class="col-md-4" [threads]="threads"></csi-jvm-threads>

    <csi-metrics-system class="col-md-4" [updating]="updatingMetrics" [systemMetrics]="metrics.processMetrics"></csi-metrics-system>
  </div>

  <csi-metrics-garbagecollector
    *ngIf="metrics && metricsKeyExists('garbageCollector')"
    [updating]="updatingMetrics"
    [garbageCollectorMetrics]="metrics.garbageCollector"
  ></csi-metrics-garbagecollector>

  <div class="well well-lg" *ngIf="updatingMetrics" csiTranslate="metrics.updating">Updating...</div>

  <csi-metrics-request
    *ngIf="metrics && metricsKeyExists('http.server.requests')"
    [updating]="updatingMetrics"
    [requestMetrics]="metrics['http.server.requests']"
  ></csi-metrics-request>

  <csi-metrics-endpoints-requests
    *ngIf="metrics && metricsKeyExists('services')"
    [updating]="updatingMetrics"
    [endpointsRequestsMetrics]="metrics.services"
  ></csi-metrics-endpoints-requests>

  <csi-metrics-cache
    *ngIf="metrics && metricsKeyExists('cache')"
    [updating]="updatingMetrics"
    [cacheMetrics]="metrics.cache"
  ></csi-metrics-cache>

  <csi-metrics-datasource
    *ngIf="metrics && metricsKeyExistsAndObjectNotEmpty('databases')"
    [updating]="updatingMetrics"
    [datasourceMetrics]="metrics.databases"
  ></csi-metrics-datasource>
</div>
